/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.constant.Constants
 *  com.ruoyi.common.core.domain.R
 *  com.ruoyi.common.core.domain.StrFile
 *  com.ruoyi.common.core.utils.file.FileUtils
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.system.api.RemoteFileService
 *  com.ruoyi.system.api.domain.SysFile
 *  com.ruoyi.system.domain.SnServer
 *  com.ruoyi.system.domain.SnSslLog
 *  com.ruoyi.system.domain.dto.DeploySSLParams
 *  com.ruoyi.system.kernel.SslNginxConfigDealKernel
 *  com.ruoyi.system.mapper.SnSslLogMapper
 *  com.ruoyi.system.utils.jsch.GeneratedSSLUtil
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.stereotype.Service
 */
package com.ruoyi.system.kernel;

import com.ruoyi.common.core.constant.Constants;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.domain.StrFile;
import com.ruoyi.common.core.utils.file.FileUtils;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.system.api.RemoteFileService;
import com.ruoyi.system.api.domain.SysFile;
import com.ruoyi.system.domain.SnServer;
import com.ruoyi.system.domain.SnSslLog;
import com.ruoyi.system.domain.dto.DeploySSLParams;
import com.ruoyi.system.mapper.SnSslLogMapper;
import com.ruoyi.system.utils.jsch.GeneratedSSLUtil;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.Date;
import java.util.List;
import org.apache.commons.lang3.tuple.Triple;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class SslNginxConfigDealKernel {
    @Autowired
    private SnSslLogMapper snSslLogMapper;
    @Autowired
    private RemoteFileService remoteFileService;

    public Triple<AjaxResult, DeploySSLParams, String> deal(DeploySSLParams params, SnServer server, String domain, String nginxConfig) {
        if (params.getType() == 1) {
            LocalDate fiveDaysAgo = LocalDate.now().plusDays(5L);
            ZonedDateTime zdt = fiveDaysAgo.atStartOfDay(ZoneId.systemDefault());
            Date date = Date.from(zdt.toInstant());
            SnSslLog param = new SnSslLog();
            param.setDomain(domain);
            param.setExpireTime(date);
            List logs = this.snSslLogMapper.selectSnSslLogList(param);
            if (!logs.isEmpty()) {
                params.setCacheSsl(Boolean.valueOf(true));
                SnSslLog log = (SnSslLog)logs.get(0);
                String pemUrl = log.getPem();
                String pemName = FileUtils.getName((String)pemUrl);
                params.setSslPem(pemUrl);
                String keyUrl = log.getKey();
                String keyName = FileUtils.getName((String)keyUrl);
                params.setSslKey(keyUrl);
                nginxConfig = nginxConfig.replace("#{ssl-config}", "http2 on;\nssl_certificate /etc/ssl/" + domain + "/" + pemName + ";\nssl_certificate_key /etc/ssl/" + domain + "/" + keyName + ";\n");
            } else {
                List ssls = GeneratedSSLUtil.readNames((SnServer)server, (String)domain);
                String pem = "/etc/ssl/" + domain + "/fullchain" + (ssls.size() + 1) + ".pem";
                String key = "/etc/ssl/" + domain + "/privkey" + (ssls.size() + 1) + ".pem";
                params.setSslPemRoute(pem);
                params.setSslKeyRoute(key);
                nginxConfig = nginxConfig.replace("#{ssl-config}", "http2 on;\nssl_certificate " + pem + ";\nssl_certificate_key " + key + ";\n");
            }
        } else if (params.getType() == 2) {
            StrFile strFile = new StrFile();
            strFile.setContent(params.getSslPem());
            strFile.setFileName("fullchain.pem");
            strFile.setContentType("text/plain");
            R r = this.remoteFileService.uploadStrToMinio(strFile);
            if (r.getCode() != Constants.SUCCESS.intValue()) {
                return Triple.of(AjaxResult.error((String)r.getMsg()), params, nginxConfig);
            }
            String pemUrl = ((SysFile)r.getData()).getUrl();
            String pemName = ((SysFile)r.getData()).getName();
            params.setSslPem(pemUrl);
            strFile = new StrFile();
            strFile.setContent(params.getSslKey());
            strFile.setFileName("privkey.pem");
            strFile.setContentType("text/plain");
            r = this.remoteFileService.uploadStrToMinio(strFile);
            if (r.getCode() != Constants.SUCCESS.intValue()) {
                return Triple.of(AjaxResult.error((String)r.getMsg()), params, nginxConfig);
            }
            String keyUrl = ((SysFile)r.getData()).getUrl();
            String keyName = ((SysFile)r.getData()).getName();
            params.setSslKey(keyUrl);
            nginxConfig = nginxConfig.replace("#{ssl-config}", "http2 on;\nssl_certificate /etc/ssl/" + domain + "/" + pemName + ";\nssl_certificate_key /etc/ssl/" + domain + "/" + keyName + ";\n");
        } else {
            return Triple.of(AjaxResult.error((String)"暂不支持该证书类型"), params, nginxConfig);
        }
        nginxConfig = nginxConfig.replace("#{server_name}", domain);
        nginxConfig = nginxConfig.replace("#{open_ssl}", "");
        return Triple.of(AjaxResult.success(), params, nginxConfig);
    }
}

